#ifndef rest_qMATRIX_H
#define rest_qMATRIX_H
// ================ Include-Files ===============================
#include "pch.h"
// #include "Matrizen.h"
// #include "Matrix.h"
// =============== Class Declaration: qMATRIX  ==================
// qMATRIX class for square coefficient matrices
// Coefficient matrix MAT(mk,mk) is stored column-wise!
// Indexing for mk starts from 0 !!!
// cf. U. Breymann: C++. Carl Hanser Verlag (1993), p.186 ff
// ==================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// Advanced teaching and study program - Commercial use not permitted.
// The author assumes no liability for incompleteness and errors!
// Version:  2023
// Compiler: C++ 
// ========= Declaration of Prototyps (header file) =================
class qMATRIX : public MATRIX
{
// Public Member Functions
// =======================
//
// **************************************************************
// * *** this part of methods is documented within the book *** * 
// **************************************************************
//
// Privat Virtual Member Functions
// ===============================
   private:
// ========
// Matrix division -> matx(s,n) = matr(i,n) / MATk(i,s)
// MATk(i,s) * matx(s,n) = matr(i,n)
// =====================================================
MATRIZEN& dividieren(MATRIZEN& matr);
//
//     Private Friend Member Functions
//     ===============================
  private:
//=========
//
// Assign matrix -> mat1.zuweisen(mat2,zweig)
   //(only copy Matrix contents)
   // ================================================
   // zweig = 0 -> mat1=mat2
   //       = 2 -> mat1=mat+mat2
   //       = 4 -> mat1=mat-mat2
friend void zuweisen(MATRIX& mat2, int zweig);
//
//     Delete temporary matrix -> mat.temporaere_matrix_loeschen()
//     ===========================================================
friend void temporaere_matrix_loeschen();
//
// ==============================================================
//     Protected Data Components -> Matrix Descriptor
//     ==============================================
   private:
// ========
//
// defsym =  1 symmetric  coefficient matrix
//             (Cholesky elimination)
//        =  0 symmetric positiv-definite coefficient matrix
//             (Gauss elimination) 
//        = -1 unsymmetric  coefficient matrix
//             (Gauss elimination)
int defsym;
//
// memory for upper matrix (staggered coefficient matrix)
MATRIX *O_matrix_staff;
//
// memory for lower matrix (staggered coefficient matrix)
//                         (only if Gauss unsymmetric)
MATRIX* U_matrix_staff;
//
// Determinant
double det;
};
// ==============================================================
#endif